/**
 * @author Joel Espinosa Longi
 * @licencia LGPL - http://www.gnu.org/licenses/lgpl.html
 */

var diaEd = (function(diaEd) {

  diaEd.currenPanel = "";

 	var diaAttrString = "#dialogAttributes";
 	var queAttrString = "#questionAttributes";
 	var ansAttrString = "#answerAttributes";
 	var micAttrString = "#micromundoAttributes";

  /**
   * 
   */
  attributesPanel = function() {};

  /**
   *
   */
  attributesPanel.prototype.show = function(panel) {
		diaEd.currentPanel = panel;

  	// hide all the attributes dialogs
		$(diaAttrString).hide();
		$(queAttrString).hide();
		$(ansAttrString).hide();
		$(micAttrString).hide();

    // show the attributes dialog
    $(panel).show();

    // fill the panel with the dialog attributes
    if (panel === diaAttrString) {
    	diaEd.dialog.fillPanel(panel);
    }

    // fill the panel with the question attributes
    else if (panel === queAttrString) {
    	diaEd.currentQuestion.fillPanel(panel);
    }

    // fill the panel with the answer attributes
    else if (panel === ansAttrString) {
    	diaEd.currentAnswer.fillPanel(panel);
    }

    // fill the panel with the microworld attributes
    else if (panel === micAttrString) {
      diaEd.currentMicromundo.fillPanel(panel);
    }

  }

  /**
   *
   */
  attributesPanel.prototype.save = function(panel) {
  	if (panel === diaAttrString) {
  		diaEd.dialog.savePanelContent(panel);
  	}

  	else if (panel === queAttrString) {
  		diaEd.currentQuestion.savePanelContent(panel);
  	}

  	else if (panel === ansAttrString) {
  		diaEd.currentAnswer.savePanelContent(panel);
  	}

    else if (panel === micAttrString) {
      diaEd.currentMicromundo.savePanelContent(panel);
    }
  }

  diaEd.attributesPanel = new attributesPanel();

  return diaEd;
})(diaEd || {});