/**
 * @author Joel Espinosa Longi
 * @licencia LGPL - http://www.gnu.org/licenses/lgpl.html
 */

var diaEd = (function(diaEd) {

  /**
   * 
   */
  diaEd.LineDrawing = function(container) {
    // this.svg = this.makeSVGElement("svg", { xmlns: "http://www.w3.org/2000/svg", 
    //                                         version: "1.1",
    //                                         width: "100%",
    //                                         height:"100%"
    //                                       });

    this.lines = [];
    this.svg = document.getElementById("elSVG");

    container.append(this.svg);

    //
    // this.poly = this.makeArrow({x:0, y:0}, {x:100, y:200})
    // this.append(this.poly);
    // this.changeArrowPosition(this.poly, {x: 100, y:200}, {x:10, y:10});
  }

  diaEd.LineDrawing.prototype.makeArrow = function(p1, p2) {
    return this.makeSVGElement("polyline", { points: this.makePathStringForPoints(p1, p2),
                                            stroke: "purple",
                                            fill: "rgba(0,0,0,0)",
                                            "stroke-width": 3,
                                            "marker-end": "url(#t)",
                                            "marker-start": "url(#s)"
                                          });
  }
  diaEd.LineDrawing.prototype.makePathStringForPoints = function(p1, p2) {
    var pmX = Math.round( (p1.x + p2.x)/2 );
    var pmY = Math.round( (p1.y + p2.y)/2 );

    return p1.x + "," + p1.y + " " + pmX + "," + p1.y + " " + pmX + "," + p2.y + " " + p2.x + "," + p2.y;
  }
  diaEd.LineDrawing.prototype.changeArrowPosition = function(e, p1, p2) {
    e.setAttribute("points", this.makePathStringForPoints(p1, p2));
  }

  diaEd.LineDrawing.prototype.makeSVGElement = function(tag, attrs) {
    var el= document.createElementNS('http://www.w3.org/2000/svg', tag);

    for (var k in attrs) {
      el.setAttribute(k, attrs[k]);
    }

    return el;    
  }

  diaEd.LineDrawing.prototype.append = function(el) {
    this.svg.appendChild(el);
  }

  /**
   *
   */
  diaEd.LineDrawing.prototype.cleanLines = function() {
    for (var i=0,l=this.lines.length; i<l; i++) {
      this.svg.removeChild(this.lines[i].line);
    }
    this.lines = [];
  }

  /**
   *
   */
  diaEd.LineDrawing.prototype.update = function() {
    var answer;
    var question;
    var iniPos;
    var endPos;
    var p1;
    var p2;
    var collapsed;
    var scrolltop = parseInt( $("#divContainer").scrollTop() );

    for (var i=0, l=this.lines.length; i<l; i++) {
      answer = this.lines[i].answer;
      question = this.lines[i].question;
      iniPos = $(answer.container).position();
      endPos = $(this.lines[i].question.container).position();
      collapsed = (answer.parentQuestion.container.accordion( "option", "active") === false);

      p1 = { x: (collapsed ? 17 : 3) + 205 + iniPos.left + $(answer.parentQuestion.container).position().left,
             y: collapsed ? (15 + $(answer.parentQuestion.container).position().top + scrolltop) : (63  + iniPos.top  + $(answer.parentQuestion.container).position().top + scrolltop)
           };
      p2 = { x: endPos.left,
             y: endPos.top +15 +scrolltop
      }

      this.changeArrowPosition(this.lines[i].line, p1, p2);

    }
  }

  /**
   *
   */
  diaEd.LineDrawing.prototype.addLine = function(answer, question) {
    var iniPos;
    var line = null;

    if (question != null) {
      iniPos = $(answer.container).position();

      var collapsed = (answer.parentQuestion.container.accordion( "option", "active" ) === false);

      line = this.makeArrow( { x: (collapsed ? 17 : 3) + 205 + iniPos.left + answer.parentQuestion.attributes.get("x"),
                               y: (collapsed ? 15 : 63) + iniPos.top  + answer.parentQuestion.attributes.get("y")
                             }, 
                             { x: question.attributes.get("x"),
                               y: question.attributes.get("y") +15
                             }
                           );
    }

    if (line != null) {
      this.append(line);
      this.lines.push({ line: line, 
                        answer: answer,
                        question: question
                      });
    }

  }

  return diaEd;
})(diaEd || {});