/**
 * @author Joel Espinosa Longi
 * @licencia LGPL - http://www.gnu.org/licenses/lgpl.html
 */

var diaEd = (function(diaEd) {

  /**
   *
   */
  diaEd.configureToolbar = function() {
    // create the icon buttons
    $("#new_btn" ).button({ icons: { primary: "my-icon-new"  }, text: false }).addClass("toolbarButton");
    $("#open_btn").button({ icons: { primary: "my-icon-open" }, text: false }).addClass("toolbarButton");
    $("#save_btn").button({ icons: { primary: "my-icon-save" }, text: false, disabled: false }).addClass("toolbarButton");

    $("#add_question_btn").button({ icons: { primary: "my-icon-add-question" }, text: false, disabled: false }).addClass("toolbarButton");
    $("#add_answer_btn").button({ icons: { primary: "my-icon-add-answer" }, text: false, disabled: false }).addClass("toolbarButton");
    $("#add_microworld_btn").button({ icons: { primary: "my-icon-add-microworld" }, text: false, disabled: false }).addClass("toolbarButton");

    // register the onclick event of the new_btn
    $("#new_btn").click(function(e) {
      e.stopPropagation();

      // show the add question button
      // $("#addQuestion").show();
      // $("#addMicromundo").show();

      // initial value of a new dialog
      var text = "";

      diaEd.filename = "dialogo.json";
      diaEd.dialog = new diaEd.Dialog(text);
      diaEd.dialog.init();

      diaEd.attributesPanel.show("#dialogAttributes");
    });

    // register the onclick event of the open_btn
    $("#open_btn").click(function(e) {
      e.stopPropagation();

      // show the add question button
      $("#addQuestion").show();
      $("#addMicromundo").show();

      $("#files").trigger("click");
    });

    // register the onclick event of the save_btn
    $("#save_btn").click(function(e) {
      e.stopPropagation();

      if (diaEd.dialog) {
        diaEd.attributesPanel.save(diaEd.currentPanel);        
        diaEd.dialog.render();
      }

      $("#save").trigger("click");
    });

    // register the onclick event of the close_btn
    $("#close_btn").click(function(e) {
      e.stopPropagation();

      // if the dialog has content
      if (diaEd.dialog != null) {
        // close the dialog
        if (confirm("Estas seguro de querer cerrar este dialgo")) {
          if ((diaEd.dialog) && (diaEd.dialog.toString() != diaEd.savedString)) {
            if (confirm("Hay información sin guardar. Quieres guardar los cambios.")) {
              $("#save").trigger("click");
            }
          }
          $("#contentEditor").empty();
          $("#micromundoEditor").empty();

          $("#dialogAttributes").hide();
          $("#questionAttributes").hide();
          $("#answerAttributes").hide();
          $("#micromundoAttributes").hide();
          $("#addQuestion").hide();
          $("#addMicromundo").hide();

          diaEd.dialog = null;
        }
      }
    });

  }

  return diaEd;
})(diaEd || {});