/**
 * @author Joel Espinosa Longi
 * @licencia LGPL - http://www.gnu.org/licenses/lgpl.html
 */

var diaEd = (function(diaEd) {

  /**
   * Implements heritage
   * @param {Object} child is the object that extends
   * @param {Object} parent is the object to extend
   */
  diaEd.extend = function(child, parent) {
    // all browser exept ie
    if (child.prototype.__proto__) {
      child.prototype.__proto__ = parent.prototype;
    }
    else { 
      // copy every function of the parent
      for( var i in parent.prototype ) { 
        if (parent.prototype.hasOwnProperty(i)) {
          child.prototype[i] = parent.prototype[i];
        }
      }
    }
    
    // uber property equivalente to super in other languages
    child.prototype.uber = parent.prototype;
  }

  return diaEd;
})(diaEd || {});