<?php

class Node{
	
	public $token;
	public $type;
	public $valor;
	public $children = array();
	
	public $lp = 0;
	public $rp = 1;
	public $op = 2;
	public $pal = 3;
	
	private $match;
	public $datosPos = array();
	private $datosPosTmp = array();
	public  $lemasMatched = array();
	private $esNeg = FALSE;
	private $neg = FALSE;
	
	
	public function setToken($t) { 
		$this->token = $t;
		$this->setType();
	}
	
	private function setType(){
		
		if($this->token == "("){
			$this->type = $this->lp;
		} else if($this->token == ")"){
			$this->type = $this->rp;	
		} else if(mb_ereg_match('(\+\+|-\>|&&|\/\/|&\+|\!|#|_)',$this->token)){
			$this->type = $this->op;
			$this->setValor();
		} else {
			$this->type = $this->pal;
		}
	}
	
	public function setValor(){
		//Ya no se necesita esto para prioridad signos
		if($this->token=="#"){
			$this->valor = 0;
		} else if($this->token=="!"){
			$this->valor = 1;
		} else if($this->token=="&&" || $this->token=="&+" || $this->token=="_"){
			$this->valor = 2;
		} else if($this->token=="//" || $this->token=="++" || $this->token=="->"){
			$this->valor = 3;
		}
	}
	
	public function addChild($n){
		array_unshift($this->children,$n);
	}
			
	public function getToken() { return $this->token; }
	
	public function getType() { return $this->type; }
	
	public function getValor() { return $this->valor; }
	
		
	public function resetAll(){
		
		$this->match = FALSE;
		$this->datosPos = array();
		$this->datosPosTmp = array();
		$this->lemasMatched = array();
		$this->esNeg = FALSE;
		$this->neg = FALSE;
		
		foreach($this->children as $child){
			$child->resetAll();
		}
	}
	
	private function reset(){
		
		$this->match = FALSE;
		$this->datosPos = array();
		$this->datosPosTmp = array();
		$this->lemasMatched = array();
		$this->esNeg = FALSE;
		$this->neg = FALSE;
	}

	
	public function analizar($n){
		
		if(count($this->children)>1){
			
			if($n==2){
				$this->reset();
			}
			
			if($this->token == "//"){
				
				$this->match = FALSE;
				foreach($this->children as $child){
					if($child->analizar($n)){
						$this->match = TRUE;
						//break; --> no se debe hacer break para considerar todas las opciones y posiciones
					}
				}
				
			} else {
			
				$this->match = TRUE;
				foreach($this->children as $child){
					if(!$child->analizar($n)){
						$this->match = FALSE;
						//break; --> no se debe hacer break para considerar todas las opciones y posiciones
					}
				}
				
				switch ($this->token) {
					
					/*
					case "&&" :	$this->match = $this->match;
							break;
					*/
						
					case "++": 	if($this->match){
								$arrPos = array();
								foreach($this->children as $child){
									array_push($arrPos,$child->getPos(array()));
								}
								$this->match = $this->checarPos($arrPos,"++");
							}
							break;
						
					case "&+":	if($this->match){
								$arrPos = array();
								foreach($this->children as $child){
									array_push($arrPos,$child->getPos(array()));
								}
								$this->match = $this->checarPos($arrPos,"&+");
							}
							break;
						
					case "_":	if($this->match){
								$arrPos = array();
								foreach($this->children as $child){
									array_push($arrPos,$child->getPos(array()));
								}
								$this->match = $this->checarPos($arrPos,"_");
							}
							break;
					
					case "->":	if($this->match){
								$arrPos = array();
								foreach($this->children as $child){
									array_push($arrPos,$child->getPos(array()));
								}
								$this->match = $this->checarPos($arrPos,"++");
							}
							if($this->match){
								$this->match = $this->checarCausa($arrPos);
							}
							break;
						
				}
			}
			
		} else if(count($this->children)==1){
			
			if($n==2){
				$this->reset();
			}
			
			switch ($this->token) {
				case "!" :	$this->match = !($this->children[0]->analizar($n));
						break;
				case "#" :	//Sólo puede haber una clave sin ops entre los paréntesis del operador NEG
						$this->match = $this->children[0]->checkMatch(0) && $this->children[0]->negacion(TRUE);
						if($this->match){
							$this->children[0]->match = TRUE; //se necesita para getPos del child
						}
						break;
			}
		} else {
			if($n==1){
				$this->match = $this->checkMatch(1);
			} elseif($n==2) {
				if($this->neg==FALSE){
					$this->reset();
					$this->match = $this->checkMatch(1);
				} else {
					if($this->checkPosNeg()){
						$this->reset();
						$this->match = $this->checkMatch(2);
					} else {
						$this->match = FALSE;
					}
				}
			}
		}
		
		return $this->match;
	}
	
	
	
	private function checkPosNeg(){
		
		global $arrPosNeg;
		
		$negAnt = FALSE;
		
		foreach($arrPosNeg as $posNeg){
			
			foreach($this->datosPosTmp as $pos){
				
				//Si están en la misma frase y la negación antecede la palabra
				if($posNeg[0]==$pos[0] && $posNeg[1]<$pos[1]){
					$negAnt = TRUE;
					break;
				}
				
			}
		}
		
		return $negAnt;
	}
        
	
        private function checarPos($arrPos,$op){
		
		$ok = TRUE;
		
		$pIni1;
		$pFin1;
		$pIni2;
		$pFin2;
		
		//Hay que checar y comparar cada 2 conjuntos de posiciones
		for($i=0;$i<count($arrPos)-1;$i++){
						
			$okLoc = FALSE;
			
			$arrPos1 = $arrPos[$i];
			$arrPos2 = $arrPos[$i+1];
			
			foreach($arrPos1 as $strPos1){
						
				$pos1 = split(",",$strPos1);
				list($pIni1,$pFin1) = $this->getPosGlobal($pos1);
				
				foreach($arrPos2 as $strPos2){
										
					$pos2 = split(",",$strPos2);
					list($pIni2,$pFin2) = $this->getPosGlobal($pos2);
					
					if($op=="++"){
						if( ($pIni1<$pIni2 && $pFin1<$pIni2) || ($pIni1>$pFin2 && $pFin1>$pFin2) ){
						    $okLoc=TRUE;
						    break;
						}
					} elseif($op=="&+"){
						if($pFin1<$pIni2){
							$okLoc=TRUE;
							break;	
						}
					} elseif($op=="_"){
						if($pIni1 == $pIni2-1){
							$okLoc=TRUE;
							break;	
						}
					}
				}
				
				if($okLoc){
					break;
				}
			}
			
			if($okLoc==FALSE){
				$ok=FALSE;
				break;
			}
		}
		
		return $ok;
        }
	
	
	private function getPosGlobal($arr){
				
		global $raices;
		
		$n = 0;
		$pIni;
		$pFin;
		
		for($j=0;$j<count($raices);$j++){  
		    if($j==$arr[0]){
			$pIni = $n+$arr[2];
		    }
		    if($j==$arr[1]){
			$pFin = $n+$arr[3];
		    }
		    $n+=count($raices[$j]);
		}
				
		return array($pIni,$pFin);
	}
	
        
        private function checarCausa($arrPos){
	    	    
            $ok = FALSE;
            
            //En causa 1 y 2 hay que agregar "POR" seguido de un infinitivo. También: TAN ... que ...
            $cnctrsCausa1 = array("dado que","ya que","porque","por que","a causa de","debido a","en vista de","como","si"); //--> Se encuentran al inicio de la oración, antes de la causa
            $cnctrsCausa2 = array("dado que","ya que","porque","por que","a causa de","debido a","en vista de","pues","si"); //--> Se encuentran al inicio de la causa, en la 2a parte de la oración
	    $cnctrsEfecto1 = array("para","a fin de","con el objeto de"); //--> Se encuentran al inicio de la oración, antes del efecto o la condición
            $cnctrsEfecto2 = array("por eso","por esto","por lo mismo","por lo que","por lo cual","debido a eso","debido a lo que","entonces","caus","para","de modo que","de manera que","así","a fin de"); //--> Se encuentran al inicio del efecto, en la 2a parte de la oración
            
	    $ok = $this->checkPosCtrCausa($cnctrsCausa1,$arrPos,"c1");
	    if($ok==FALSE){
		$ok = $this->checkPosCtrCausa($cnctrsCausa2,$arrPos,"c2");
	    }
	    if($ok==FALSE){
		$ok = $this->checkPosCtrCausa($cnctrsEfecto1,$arrPos,"e1");
	    }
	    if($ok==FALSE){
		$ok = $this->checkPosCtrCausa($cnctrsEfecto2,$arrPos,"e2");
	    }

            return $ok;
        }
	
	private function checkPosCtrCausa($ctrs,$arrPos,$tipo){
				
		$match = FALSE;
		
		$str="(";
		foreach($ctrs as $ctr){
		    if($str!="("){
			    $str.="//";
		    }
		    $str .= "(" . mb_ereg_replace(' ','_',$ctr). ")";
		}
		$str.=")";
		
		$toks = getTokens($str);
		list($WS,$error) = parsear($toks);
		if($error==0){
		    $match = $WS[0]->analizar(1);
		}
		
		if($match){
		    $posCtr = $WS[0]->getPos(array());
		    $match = $this->checarPosCausa($posCtr,$arrPos,$tipo);
		}
		
		return $match;
	}
	
	
	private function checarPosCausa($arrPosCtr,$arrPos,$tipo){
		
		$ok = FALSE;
				
		if(count($arrPos)==2){
			
			$arrPosC = $arrPos[0];
			$arrPosE = $arrPos[1];
			
			foreach($arrPosCtr as $strPosCtr){
					        
				$posCtr = split(",",$strPosCtr);
				list($pIniCtr,$pFinCtr) = $this->getPosGlobal($posCtr);
			
				foreach($arrPosC as $strPosC){
									
					$posC = split(",",$strPosC);
					list($pIniC,$pFinC) = $this->getPosGlobal($posC);
					
					foreach($arrPosE as $strPosE){
											
						$posE = split(",",$strPosE);
						list($pIniE,$pFinE) = $this->getPosGlobal($posE);
					
						if($tipo=="c1"){
							if( $pFinCtr<$pIniC && $pFinC<$pIniE ){
								$ok = TRUE;
								break;
							}
						} elseif($tipo=="c2"){
							if( $pFinE<$pIniCtr && $pFinCtr<$pIniC ){
								$ok = TRUE;
								break;
							}
						} elseif($tipo=="e1"){
							if( $pFinCtr<$pIniE && $pFinE<$pIniC ){
								$ok = TRUE;
								break;
							}
						} elseif($tipo=="e2"){
							if( $pFinC<$pIniCtr && $pFinCtr<$pIniE ){
								$ok = TRUE;
								break;
							}
						}
					}
								
					if($ok){
						break;
					}
				}
				
				if($ok){
					break;
				}
				
			}
			
		} else {
			echo "El operador CAU puede unir 2 y sólo 2 expresiones.";
		}
				
		return $ok;
	}
	
	
	
	public function checkMatch($checkNeg){
		
		global $raices,$raicesMatched;
		
		$strPals = $this->token;	
		$pals = split(",",$strPals);
		$m = FALSE;
		
		for($f=0;$f<count($raices);$f++){
			for($p=0;$p<count($raices[$f]);$p++){	
				foreach($raices[$f][$p] as $lema => $arrPals){
					for($i=0;$i<count($pals);$i++){
						if($lema==$pals[$i]){
							array_push($this->lemasMatched,$lema);
							array_push($this->datosPosTmp,array($f,$p));
						}
					}
				}
			}
		}
				
		if(count($this->lemasMatched)>0){
			if($checkNeg==1){
				$m = !($this->negacion(FALSE));
			} elseif($checkNeg==2){
				$this->datosPos = $this->datosPosTmp;
				for($l=0;$l<count($this->lemasMatched);$l++){
					$arr = $this->datosPos[$l];
					array_push($arr,$this->lemasMatched[$l]);
					array_push($raicesMatched,$arr);
				}
				$m = TRUE;
			} else {
				$m = TRUE;
			}
		} 
		
		return $m;
	}
	
	
	public function negacion($desdeNEG){
		
		global $raices,$raicesMatched;
		global $huboNeg,$huboNegado,$arrPosNeg;
		
		$hayNeg = FALSE;
		
		$negs = array("no","nunca","jamás","jamas","nada","nadie","ningún","ningun","ninguno","ninguna","ni","nul","sin");
		$nexosSubord = array("que","quien","donde","cuando","cual","cuales");
					
		for($i=0;$i<count($this->datosPosTmp);$i++){
			
			$arrPos = $this->datosPosTmp[$i];
			$mf = $arrPos[0];  // match frase
			$mp = $arrPos[1];  // match pos
					
			//negación antes y después de subordinación (no creo que no ...)
			$negAnt=0;
			$negDesp=0;
			$subord=FALSE;
			$mpSub=-1;
			
			for($p=0;$p<$mp;$p++){
				
				foreach($raices[$mf][$p] as $lema => $arrPals){
				//for($l=0;$l<count($raices[$mf][$p]);$l++){
					
					//array_push($arrPosNeg,array($mf,$p)); //ME PARECE QUE ESTA MAL AQUÍ									
					if(in_array($lema,$negs)){
						array_push($arrPosNeg,array($mf,$p));
						if($subord){
							$negDesp++;
						} else {
							$negAnt++;
						}
						break;
					} else if(in_array($lema,$nexosSubord)){
						$subord=TRUE;
						$mpSub = $p;
						break;
					}
				}
			}
					
			if( ($subord==FALSE && $negAnt>0) ||  ($subord==TRUE && ( ($negAnt==0 && $negDesp>0) || ($negAnt>0 && $negDesp==0) ) ) ){
				if($desdeNEG){
					$hayNeg = TRUE;
					$this->esNeg = TRUE;
					$huboNeg = TRUE;
					$arr = $this->datosPosTmp[$i];
					array_push($this->datosPos,$arr);
					array_push($arr,$this->lemasMatched[$i]);
					array_push($raicesMatched,$arr);
				} 
			} else {
				if($desdeNEG==FALSE){
					$arr = $this->datosPosTmp[$i];
					array_push($this->datosPos,$arr);
					array_push($arr,$this->lemasMatched[$i]);
					array_push($raicesMatched,$arr);
				}
			}
		}
		
		if($desdeNEG==FALSE && count($this->datosPos)==0){
			$hayNeg = TRUE;
			$this->neg = TRUE;
			$huboNegado = TRUE;
		}
							
		return $hayNeg;
	}
	
	
	
	private function getPos($arrDatos){	
		
		if($this->match){
			if(count($this->children)>0){
				foreach($this->children as $child){
					$dCh = $child->getPos($arrDatos);
					if(count($dCh) > 0){
						$arrDatos = $this->compararDatos($arrDatos,$dCh);						
					}
				}
			} else {
				if(count($this->datosPos)>0){ //Hubo que agregar esta condición porque $this->match daba true incorrectamente en algunos casos
					$arrDatos = $this->getIniFin();
				} else {
					$arrDatos = array();
				}
			}
		}
		
		return $arrDatos;
	}
	
	
	private function getIniFin(){
		
		$newDatos = array();
		
		foreach($this->datosPos as $arrPos){
				
			$f = $arrPos[0];
			$p = $arrPos[1];
		
			array_push($newDatos,"$f,$f,$p,$p");
		}
		
		return $newDatos;
	}
	
	
	private function compararDatos($arrViejo,$arrNuevo){
		
		$newDatos = array();
		
		foreach($arrNuevo as $dNuevos){
			
			list($fi,$ff,$pi,$pf) = split(",",$dNuevos);
			
			if(count($arrViejo)==0){
				
				array_push($newDatos,"$fi,$ff,$pi,$pf");
				
			} else {
				
				foreach($arrViejo as $dViejos){
				
					list($fIni,$fFin,$pIni,$pFin) = split(",",$dViejos);
				
					if($fi<$fIni){
						$fIni=$fi;
						$pIni = $pi;
					} else {
						if($pi<$pIni){
							$pIni=$pi;
						}
					}
					
					if($ff>$fFin){
						$fFin = $ff;
						$pFin = $pf;
					} else {
						if($pf>$pFin){
							$pFin=$pf;
						}
					}
					
					array_push($newDatos,"$fIni,$fFin,$pIni,$pFin");
				}
			}
		}
		
		return $newDatos;
	}

	
}

?>