<?php

header('Content-Type: text/html; charset=utf-8');

include 'funcionesCompartidas.php';
include 'expresionesEquivalentes_editor.php';
include 'class.xmlresponse.php';

// en eswn_synset, los synsets aparecen máx. una vez por POS
// cuando hay gloss en esWN-synset, no hay más sinónimos en esWM-variant

/*
RELACIONES CON VERBOS
has_hyponym: v-v
causes:  v-v
///has_subevent:  v-v
///see_also_wn15:  v-v
xpos_near_synonym:  n-v
near_antonym:  v-v
role:  n-v
role_agent:   n-v
role_instrument:   n-v
role_patient:   n-v
role_location:  n-v
xpos_fuzzynym:  n-v
*/

$pal = urldecode($_GET["q"]);
$tipoPal="";

$relacionesV = array('Sinónimos','Hipónimos','Hiperónimos','Es causa de','Es consecuencia de','Tiene sub-evento','Es sub-evento de','Casi-sinónimo con xPos','xpos-fuzzynym','Antónimos','Role','Role-agent','Role-instrument','Role-patient','Role-location','See-also-wn15','Verbo-sust-adj','Expresiones equivalentes');
$relacionesN = array('Sinónimos','Hipónimos','Hiperónimos','Xpos-near-synonym','Xpos-hyponym','Xpos-fuzzynym','Near-antonym','Has-holo-part','Has-holo-member','Has-mero-part','Be-in-state','Pertains-to','Role','Role-agent','Role-instrument','Role-patient','Role-location','Verbo-sust-adj','Expresiones equivalentes');
$relacionesA = array('Sinónimos','Near-synonym','Xpos-near-synonym','Has-xpos-hyponym','Near-antonym','Pertains-to','Has-derived','Be-in-state','See-also-wn15','Verbo-sust-adj','Expresiones equivalentes');

$obj_v = array();
$obj_n = array();
$obj_a = array();

$synsets = getSynsets($pal);

foreach($synsets as $ss=>$pos){
	
	$str = getSinonimos($ss,$pal);
	
	if($pos=="v"){
		
		// get hipónimos, hiperónimos, xpos_near_synonym, role_agent, role_instrument, role
		$str .= "|".getPalsRels_source($ss,'has_hyponym');
		$str .= "|".getPalsRels_target($ss,'has_hyponym');
		$str .= "|".getPalsRels_source($ss,'causes');
		$str .= "|".getPalsRels_target($ss,'causes');
		$str .= "|".getPalsRels_source($ss,'has_subevent');
		$str .= "|".getPalsRels_target($ss,'has_subevent');
		$str .= "|".getPalsRels_target($ss,'xpos_near_synonym');
		$str .= "|".getPalsRels_target($ss,'xpos_fuzzynym');
		$str .= "|".getPalsRels($ss,'near_antonym');
		$str .= "|".getPalsRels_target($ss,'role');
		$str .= "|".getPalsRels_target($ss,'role_agent');
		$str .= "|".getPalsRels_target($ss,'role_instrument');
		$str .= "|".getPalsRels_target($ss,'role_patient');
		$str .= "|".getPalsRels_target($ss,'role_location');
		$str .= "|".getPalsRels($ss,'see_also_wn15');
		
		$obj_v[$ss] = $str;
	
	} else if($pos=='n'){
		
		//has_hyponym:n-n, has_holo_part:n-n, has_holo_member: n-n, has_mero_part: n-n, pertains_to: a-n, be_in_state: n-a
		//role:  n-v, role_agent:   n-v, role_instrument:   n-v, role_patient:   n-v, role_location:  n-v
		//near_antonym: n-n, xpos_near_synonym: n-v/n-a/a-n, has_xpos_hyponym: n-a, xpos_fuzzynym: n-v
		$str .= "|".getPalsRels_source($ss,'has_hyponym');
		$str .= "|".getPalsRels_target($ss,'has_hyponym');
		$str .= "|".getPalsRels($ss,'xpos_near_synonym');
		$str .= "|".getPalsRels_source($ss,'has_xpos_hyponym');
		$str .= "|".getPalsRels_source($ss,'xpos_fuzzynym');
		$str .= "|".getPalsRels($ss,'near_antonym');
		$str .= "|".getPalsRels($ss,'has_holo_part');
		$str .= "|".getPalsRels($ss,'has_holo_member');
		$str .= "|".getPalsRels($ss,'has_mero_part');
		$str .= "|".getPalsRels_source($ss,'be_in_state');
		$str .= "|".getPalsRels_target($ss,'pertains_to');
		$str .= "|".getPalsRels_source($ss,'role');
		$str .= "|".getPalsRels_source($ss,'role_agent');
		$str .= "|".getPalsRels_source($ss,'role_instrument');
		$str .= "|".getPalsRels_source($ss,'role_patient');
		$str .= "|".getPalsRels_source($ss,'role_location');
		
		$obj_n[$ss] = $str;
		
	} else if($pos=='a'){
		
		//near_synonym: a-a, near_antonym: a-a, pertains_to: a-n; be_in_state:  n-a; see_also_wn15:  a-a; has_derived: r-a; 
		//xpos_near_synonym: n-a/a-n, has_xpos_hyponym: n-a
		$str .= "|".getPalsRels($ss,'near_synonym');
		$str .= "|".getPalsRels($ss,'xpos_near_synonym');
		$str .= "|".getPalsRels_target($ss,'has_xpos_hyponym');
		$str .= "|".getPalsRels($ss,'near_antonym');
		$str .= "|".getPalsRels_source($ss,'pertains_to');
		$str .= "|".getPalsRels_target($ss,'has_derived');
		$str .= "|".getPalsRels_target($ss,'be_in_state');
		$str .= "|".getPalsRels_target($ss,'see_also_wn15');
		
		$obj_a[$ss] = $str;
	}
	
}

$ss = "Todos los synsets";
if($pos=='n'){
	$str = "|||||||||||||||||";
	$str .= join(", ",getVerbSustAdj($pal));
	$str .= "|".getExprEq($pal);
	$obj_n[$ss] = $str;
} elseif($pos=='a'){
	$str = "|||||||||";
	$str .= join(", ",getVerbSustAdj($pal));
	$str .= "|".getExprEq($pal);
	$obj_a[$ss] = $str;
} elseif($pos=='v'){
	$str = "||||||||||||||||";
	$str .= join(", ",getVerbSustAdj($pal));
	$str .= "|".getExprEq($pal);
	$obj_v[$ss] = $str;
}



$xml = new xmlResponse();
$xml->start();
$xml->command("verb", $relacionesV, $obj_v);
$xml->command("adj", $relacionesA, $obj_a);
$xml->command("sust", $relacionesN, $obj_n);
$xml->end();



///FUNCIONES && QUERIES DB


function getSynsets($pal){
	
	$arrSS = array();
	
	$dbh = connectToDB();
	mysql_select_db("esWN", $dbh);
	
	$query  = "SELECT * FROM eswn_variant_utf8 WHERE word='$pal'"; 
	$result = mysql_query($query,$dbh);
	while($row = mysql_fetch_array($result)){
		$ss = $row['offset'];
		$arrSS[$ss] = $row['pos'];
	}
	
	//mysql_close($dbh);
	
	return $arrSS;
}


function getSinonimos($ss,$pal){

	$syns = "";
	
	$dbh = connectToDB();
	mysql_select_db("esWN", $dbh);
	
	$query  = "SELECT * FROM eswn_variant_utf8 WHERE offset='$ss'"; 
	$result = mysql_query($query,$dbh);
	while($row = mysql_fetch_array($result)){
		if($row['word']!=$pal){
			$word = $row['word'];
			$word = preg_replace('/_/',' ', $word);
			$syns = $syns.$word.", ";
		}
	}
	
	if($syns!=""){
		$syns = substr($syns, 0, -2);
	} 
	
	return $syns;
}



function getPalsRels($ss,$rel){
	
	global $pal;
	$newSynsets=array();
	$newPals=array();
	$str = "";
	
	$dbh = connectToDB();
	mysql_select_db("esWN", $dbh);
	
	$query  = "SELECT * FROM eswn_relation WHERE ( ( (sourceSynset='$ss') OR (targetSynset='$ss') ) AND (relation='$rel') )";
	$result = mysql_query($query,$dbh);
	while($row = mysql_fetch_array($result)){
		if($row['targetSynset']==$ss){
			array_push($newSynsets,$row['sourceSynset']);
		} else {
			array_push($newSynsets,$row['targetSynset']);
		}
	}
	
	for($n=0;$n<count($newSynsets);$n++){
		$newSs = $newSynsets[$n];
		$query  = "SELECT * FROM eswn_variant_utf8 WHERE offset='$newSs'";
		$result = mysql_query($query,$dbh);
		while($row = mysql_fetch_array($result)){
			if(yaEstaEnArray($row['word'],$newPals)=="no"){
				$word = $row['word'];
				$word = preg_replace('/_/',' ', $word);
				array_push($newPals,$word);
			}
		}
	}
	
	$str = join(", ",$newPals);
	return $str;
}



function getPalsRels_source($ss,$rel){
	
	global $pal;
	$newSynsets=array();
	$newPals=array();
	$str = "";
	
	$dbh = connectToDB();
	mysql_select_db("esWN", $dbh);
	
	$query  = "SELECT * FROM eswn_relation WHERE ( (sourceSynset='$ss') AND (relation='$rel') )";
	$result = mysql_query($query,$dbh);
	while($row = mysql_fetch_array($result)){
		array_push($newSynsets,$row['targetSynset']);
	}
	for($n=0;$n<count($newSynsets);$n++){
		$newSs = $newSynsets[$n];
		$query  = "SELECT * FROM eswn_variant_utf8 WHERE offset='$newSs'";
		$result = mysql_query($query,$dbh);
		while($row = mysql_fetch_array($result)){
			if(yaEstaEnArray($row['word'],$newPals)=="no"){
				$word = $row['word'];
				$word = preg_replace('/_/', ' ', $word);
				array_push($newPals,$word);
			}
		}
	}
	
	$str = join(", ",$newPals);
	return $str;
}


function getPalsRels_target($ss,$rel){
	
	global $pal;
	$newSynsets=array();
	$newPals=array();
	$str = "";
	
	$dbh = connectToDB();
	mysql_select_db("esWN", $dbh);
	
	$query  = "SELECT * FROM eswn_relation WHERE ( (targetSynset='$ss') AND (relation='$rel') )";
	$result = mysql_query($query,$dbh);
	while($row = mysql_fetch_array($result)){
		array_push($newSynsets,$row['sourceSynset']);
	}
	for($n=0;$n<count($newSynsets);$n++){
		$newSs = $newSynsets[$n];
		$query  = "SELECT * FROM eswn_variant_utf8 WHERE offset='$newSs'";
		$result = mysql_query($query,$dbh);
		while($row = mysql_fetch_array($result)){
			if(yaEstaEnArray($row['word'],$newPals)=="no"){ //&&$row['word']!=$pal
				$word = $row['word'];
				$word = preg_replace('/_/',' ', $word);
				array_push($newPals,$word);
			}
		}
	}
	
	$str = join(", ",$newPals);
	return $str;
}


function yaEstaEnArray($w,$arr){
	$ya = "no";
	for($i=0;$i<count($arr);$i++){
		if($arr[$i]==$w){
			$ya = "si";	
			break;
		}
	}
	return $ya;	
}


?>