<?php

header('Content-Type: text/html; charset=utf-8');
mb_internal_encoding("UTF-8");

//include "levenshtein_matriz.php";
include "levenshtein_php.php";


$ld1 = array();
$ld2 = array();
$sug1 = array();
$sug2 = array();

$abc = array("a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","ñ");  // "á","é","í","ó","ú","ü" --> ya no se necesitan por nueva función addAcentos()


function getCorreccionLevenshtein_dst($s,$dst,$getSug){
	
	global $ld1, $ld2;
	global $sug2;
	
	if($dst==1){
		$ld1 = operaciones($s);
		if($getSug){
			getSugerencias();
		}
	} else {
		$sug2 = getPalabrasLevenshteinPHP($s,$dst);
	}
}


function getCorreccionLevenshtein($s,$l){
	
	global $ld1, $ld2;
	global $sug1, $sug2;
	
	///PASO 1: Hacer las operaciones (sustituir, agregar, eliminar letra + invertir letras) para obtener las alternativas
	$ld1 = operaciones($s);
	///PASO 2
	getSugerencias();
		
	if(count($sug1)==0 && mb_strlen($s,'UTF-8')>$l){
		$sug2 = getPalabrasLevenshteinPHP($s,2);
	}
}



function operaciones($pal){
	$arr1 = sustituirLetras($pal);
	$arr2 = agregarLetras($pal);
	$arr3 = eliminarLetras($pal);
	$arr4 = invertir($pal);
	$arrTot = array_merge((array)$arr1,(array)$arr2,(array)$arr3,(array)$arr4);
	$arrTot = addAcentos_arr($arrTot);
	return $arrTot;
}

function sustituirLetras($pal){
	global $abc;
	$arr = array();
	for($i=0;$i<mb_strlen($pal,'UTF-8')+1;$i++){
		for($j=0;$j<count($abc);$j++){
			//$pal2 = substr_replace($pal,$abc[$j],$i,1);
			$pal2 = mb_substr($pal,0,$i,'UTF-8').$abc[$j].mb_substr($pal,$i+1,mb_strlen($pal,'UTF-8')-($i+1),'UTF-8');
			array_push($arr,$pal2);
		}
	}
	return $arr;
}

function agregarLetras($pal){
	global $abc;
	$arr = array();
	for($i=0;$i<mb_strlen($pal,'UTF-8')+1;$i++){
		for($j=0;$j<count($abc);$j++){
			//$pal2 = substr_replace($pal,$abc[$j],$i,0);
			$pal2 = mb_substr($pal,0,$i,'UTF-8').$abc[$j].mb_substr($pal,$i,mb_strlen($pal,'UTF-8')-$i,'UTF-8');
			array_push($arr,$pal2);
		}
	}
	return $arr;
}

function eliminarLetras($pal){
	$arr = array();
	for($i=0;$i<mb_strlen($pal,'UTF-8')+1;$i++){
		$pal2 = mb_substr($pal,0,$i,'UTF-8').mb_substr($pal,$i+1,mb_strlen($pal,'UTF-8')-($i+1),'UTF-8');
		//$pal2 = substr_replace($pal,"",$i,1);
		array_push($arr,$pal2);
	}
	return $arr;
}


function invertir($pal){
	$arr = array();
	for($i=0;$i<mb_strlen($pal,'UTF-8')-1;$i++){
		$char1 = mb_substr($pal,$i,1,'UTF-8');
		$char2 = mb_substr($pal,$i+1,1,'UTF-8');
		$pal2 = mb_substr($pal,0,$i,'UTF-8').$char2.$char1.mb_substr($pal,$i+2,mb_strlen($pal,'UTF-8')-($i+2),'UTF-8');
		array_push($arr,$pal2);
		//array_push($arr,substr_replace($pal,$char2.$char1,$i,2));
	}
	return $arr;
}

function addAcentos_arr($arr){
	
	$arr2 = array();
	
	foreach($arr as $seed){
		$newSeeds = addAcentos($seed);
		$arr2 = array_merge((array)$arr2,(array)$newSeeds);
	}
	
	return array_merge((array)$arr,(array)$arr2);
}

//PASO 2: comparar las alternativas obtenidas con las palabras en el diccionario morfológico

function getSugerencias(){
	
	global $ld1,$sug1;
	
	$sug1 = array();
	
	for($i=0;$i<count($ld1);$i++){

		$sugLoc = consultDB($ld1[$i],"morf_utf8","palabra");
		
		if(count($sugLoc)==0){
			$sugLoc = dbSecundarias($ld1[$i],"palabra");
		}
		
		$sug1 = array_merge((array)$sug1,(array)$sugLoc);
	}
}


?>