<?php

header('Content-Type: text/html; charset=utf-8');

mb_internal_encoding("UTF-8");

include 'erroresFrecuentes.php';
include 'levenshtein.php';
include 'similarTxt.php';
//include 'corrOrto_dialogo.php';
include 'funcionesCompartidas.php';
include 'class.Node.php';
//include 'expresionesEquivalentes.php';

error_reporting(E_ERROR | E_PARSE); //NO incluyo E_WARNING PORQUE PUEDE ALTERAR LOS STRINGS DE ECHO Y, POR ENDE, EL RESULTADO


$ex = urldecode($_POST["e"]); 
$or = urldecode($_POST["o"]);
$lms = urldecode($_POST["l"]);
$corr = $_POST["c"];
//$tit = $_POST["d"];


/*
$ex = "((aumentar,incrementar,crecer,alzar,subir,levantar,elevar,ascender,mayor,calentar,calienteOR(másANDalto)))";
$or = "se alentara";
$lms = "se->se//alentaram->/alentar->alentara,alentaran,alentaras,alentará,alentarán,alentarás/nivelCorreccion->2";
$corr = "auto";
*/

/*
$ex = urldecode($_GET["e"]); 
$or = urldecode($_GET["o"]);
$lms = urldecode($_GET["l"]);
$corr = $_GET["c"];
*/

$or = trim($or);

if(!mb_check_encoding($or, 'UTF-8')) $or = utf8_encode($or);
if(!mb_check_encoding($ex, 'UTF-8')) $ex = utf8_encode($ex);


$vuelta = 1;
$huboNeg = FALSE;
$huboNegado = FALSE;
$arrPosNeg = array();

$raicesMatched = array();


//PASO 0: Get array de frases y array 2D de palabras de la respuesta

$frases = mb_split('[.,;:¿?!¡]+',$or);
$pals = separarPalsFrase($frases);

function separarPalsFrase($frases){
	
	$arr2D = array();
	$re = '/([\w\dáéíóúüñÁÉÍÓÚÜÑ]+)/i';
	
	for($f=0;$f<count($frases);$f++){
		$arr = array();
		preg_match_all($re,$frases[$f],$matches,PREG_OFFSET_CAPTURE);
		$matchesPals = $matches[1];
		for($i=0;$i<count($matchesPals);$i++){
			$palabra = $matchesPals[$i][0];
			array_push($arr,$palabra);
		}
		array_push($arr2D,$arr);
	}
	
	return $arr2D;
}



// PASO 1: Convertir lms (string con lemas obtenido en getLemas.php) en  array de 4 dimensiones

$raices = reconstuirRaices($lms);

function reconstuirRaices($lms){
	
	$raices = array();
	
	$arrFrases = mb_split('\/\/\/',$lms);
	foreach($arrFrases as $strPos){
		$pos = array();
		$arrPos = mb_split('\/\/',$strPos);
		foreach($arrPos as $strLemas){
			$lemas = array();
			$arrLemas = mb_split('\/',$strLemas);
			foreach($arrLemas as $str){
				$arr = mb_split("->",$str);
				$lema = $arr[0];
				$pals = mb_split(",",$arr[1]);
				$lemas[$lema] = $pals;
			}
			array_push($pos,$lemas);
		}
		array_push($raices,$pos);
	}
	return $raices;
}



//// PASO 2: Preparar la expresión lógica

$patrones = array();
$patrones[0] = '/AND/';
$patrones[1] = '/OR/';
$patrones[2] = '/NOT/';
$patrones[3] = '/NEG/';
$patrones[4] = '/MAS/';
$patrones[5] = '/CAU/';
$patrones[6] = '/SEG/';

$sustituciones = array();
$sustituciones[0] = '&&';
$sustituciones[1] = '//';
$sustituciones[2] = '!';
$sustituciones[3] = '#';
$sustituciones[4] = '++';
$sustituciones[5] = '->';
$sustituciones[6] = '&+';


if($ex!="(NEG)" && $ex!="(AFIR)" && $ex!="(DUDA)"){
	$ex = preg_replace($patrones, $sustituciones, $ex);
}


// PASO 3: TOKENIZATION

if($ex!="(NEG)" && $ex!="(AFIR)" && $ex!="(DUDA)"){
	$toks = getTokens($ex);
}

// PASO 4: PARSEAR EXPRESIÓN

$WS = array(); //word stack
$error = 0;
   
if($ex=="(DUDA)"){
    $tok = "no sé,no se,no lo sé,no lo se,ni idea,quien sabe,quién sabe,ve tu a saber,ve tú a saber,quizá,quizás,quiza,a lo mejor";
    $nodo = new Node();
    $nodo->setToken($tok);
    array_push($WS,$nodo);
} else if($ex=="(NEG)"){
        $tokNeg = "no,nop,nope,nada,nel,en absoluto,negativo,de ninguna manera,de ningún modo,dos tres,mas o menos,más o menos";
        $tokDuda = "no sé,no se,no lo sé,no lo se,ni idea,quien sabe,quién sabe,ve tu a saber,ve tú a saber";
        $nodoNeg = new Node();
        $nodoNeg->setToken($tokNeg);
        $nodoDuda = new Node();
        $nodoDuda->setToken($tokDuda);
	$nodoNOT = new Node();
	$nodoNOT->setToken("!");
	$nodoNOT->addChild($nodoDuda);
        $nodo = new Node();
        $nodo->setToken("&&");
	$nodo->addChild($nodoNeg);	
	$nodo->addChild($nodoNOT);
        //$nodo->setLeft($nodoNeg);
        //$nodo->setRight($nodoDuda);
        array_push($WS,$nodo);
} else if($ex=="(AFIR)"){
        $tokAfir = "si,sí,sip,sipi,aja,ajá,claro,ok,venga,simon,simón,por supuesto,sin duda,seguro,seguramente,cierto,ciertamente,de acuerdo,así es,obviamente,obvio,evidentemente,afirmativo";
        $tokNeg = "no,nop,nope,nada,nel,en absoluto,negativo,de ninguna manera,de ningún modo";
        $nodoAfir = new Node();
        $nodoAfir->setToken($tokAfir);
        $nodoNeg = new Node();
        $nodoNeg->setToken($tokNeg);
	$nodoNOT = new Node();
	$nodoNOT->setToken("!");
	$nodoNOT->addChild($nodoNeg);
        $nodo = new Node();
        $nodo->setToken("&&");
	$nodo->addChild($nodoAfir);
	$nodo->addChild($nodoNOT);
        //$nodo->setLeft($nodoAfir);
        //Para interpretar bien expresiones como: claro que no, obviamente no, ...
        //$nodo->setRight($nodoNeg);
        array_push($WS,$nodo);
} else {
        list($WS,$error) = parsear($toks);
}


///PASO 5: ANALIZAR ÁRBOL
$match = FALSE;

if($error==0){
	$match = $WS[0]->analizar(1);
}

//// PASO 6: OUTPUT

printOutput();




/////////////////       FUNCIONES     //////////////////////





/// PASO 3

function getTokens($ex){
		
	$toks = array();
	$reLetra = '[\w\dáéíóúüñ\-,]';
	$reOp = '[&\/\!\#\+\-\>_]';
	$reOpCompl = '(\+\+|&&|\/\/|&\+|\!|\#|\-\>|_)';
	$pal = "";
	$op = "";
	
	for($l=0;$l<strlen($ex);$l++){
		
		if(mb_ereg_match($reOp,mb_substr($ex,$l,1)) ){
			if($pal!=""){
				array_push($toks,$pal);
				$pal = "";
			}
			$op.=mb_substr($ex,$l,1);
			if(mb_ereg_match($reOpCompl,$op)){
				array_push($toks,$op);
				$op = "";
			}
		} else if(mb_substr($ex,$l,1)=="("){
			array_push($toks,"(");
		} else if(mb_substr($ex,$l,1)==")"){
			if($pal!=""){
				array_push($toks,$pal);
				$pal = "";
			}
			array_push($toks,")");
		} else {
			$pal.=mb_substr($ex,$l,1);
		}
	}
	
	return $toks;
}


/// PASO 4


function parsear($toks){
		

	$OS = array();
	$WS = array();
	$error = 0;

	$countLp = 0;

	for($i=0;$i<count($toks);$i++){
		$tok = $toks[$i];
		$nodo = new Node();
		$nodo->setToken($tok);
		if($nodo->type==$nodo->lp){
			array_push($OS,$nodo);
			$countLp++;
		} else if($nodo->type==$nodo->op){
			array_push($OS,$nodo);
		} else if($nodo->type==$nodo->pal){
			array_push($WS,$nodo);
		} else if($nodo->type==$nodo->rp){
			if($countLp>0){
				list($OS,$WS,$error) = crearNodo($OS,$WS);
				//Quitar el left parentesis
				if($OS[count($OS)-1]->type == $OS[count($OS)-1]->lp){
					array_pop($OS);
					$countLp--;
				} else {
					$error=3;
				}
				// checar si operador anterior es NEG (0) o NOT (1) -> prioridad
				$opAnt = $OS[count($OS)-1];
				if(count($OS)>0 && $opAnt->type==$opAnt->op && $opAnt->valor<2){
					list($OS,$WS,$error) = crearSimpleNode($OS,$WS);
				}
			} else {
				$error=1;
			}
		}
	}
	
	if($countLp>0){
		$error=2;
	}
	
	if($error==0 && count($OS)>0){
		list($OS,$WS,$error) = toOneNode($OS,$WS);
	}
	
	return array($WS,$error);
}


function crearNodo($OS,$WS){
	        		
	$error = 0;
	
	$opNodes = array();
	
	while(count($OS)>0 && $OS[count($OS)-1]->type ==  $OS[count($OS)-1]->op){
		array_push($opNodes,array_pop($OS));
	}
	
	if(count($opNodes)==0){ //Se trata de una clave entre paréntesis
		//No hacer nada; el lp se quita más adelante
	} elseif(count($opNodes)==1){ //Hay un solo operador entre los paréntesis
		$nodo = $opNodes[0];
		if($nodo->valor>=2 && count($WS)>=2){
			$nodo->addChild(array_pop($WS));
			$nodo->addChild(array_pop($WS));
			array_push($WS,$nodo);
		} elseif($OS[count($OS)-1]->type == $OS[count($OS)-1]->lp){ //ya sólo hay un lp en OS
			array_push($WS,$nodo);
		} else {
			$error=4;
		}
	} else { //Hay múltiples operadores (todos los mismo) entre el mismo par de paréntesis
		$same=TRUE;
		for($o=1;$o<count($opNodes);$o++){
			if($opNodes[$o]->token!=$opNodes[$o-1]->token){
				$same=FALSE;
				break;
			}
		}
		if($same){
			$nodo = $opNodes[0];
			if(count($WS)>count($opNodes)){
				for($i=0;$i<=count($opNodes);$i++){
					$nodo->addChild(array_pop($WS));
				}
				array_push($WS,$nodo);
			} else {
				$error=5;
			}
		} else {
			$error=6;
		}
	}
	
	return array($OS,$WS,$error);
}


function crearSimpleNode($OS,$WS){
	
	$error = 0;
	
	$nodo = array_pop($OS);
	if(count($WS)>=1){
		$nodo->addChild(array_pop($WS));
		array_push($WS,$nodo);
	} else {
		$error=7;
	}
	
	return array($OS,$WS,$error);
}


function toOneNode($OS,$WS){
		
	//global $OS;
	
	$error = 0;
	
	if($OS[count($OS)-1]->type==$OS[count($OS)-1]->op){
		if($OS[count($OS)-1]->valor<2){
			list($OS,$WS,$error) = crearSimpleNode($OS,$WS);
		} else {
			list($OS,$WS,$error) = crearNodo($OS,$WS);
		}
		if(count($OS)>0){
			list($OS,$WS,$error) = toOneNode($OS,$WS);
		}
	} else {
		$error=8;
	}
	
	return array($OS,$WS,$error);
}




/// PASO 6

function printOutput(){
    
    global $error,$match,$vuelta,$corr,$pals;
    global $huboNeg,$huboNegado,$WS;

    if($error==0){
            if($match==TRUE){
		if($corr=="on"){
			echo "true|".getCorreccionSugerida();
		} else {
			echo "true|";
		}
            } else {
		if($huboNeg && $huboNegado){
			$match = $WS[0]->analizar(2);
			$huboNeg = FALSE;
			$huboNegado = FALSE;
			$arrPosNeg = array();
			printOutput();
		} else {
			if($corr!="off" && $vuelta==1){
			    $vuelta++;
			    segundaVuelta();
			} else {
				if($corr=="on"){
					echo "false|".getCorreccionSugerida();
				} else {
					echo "false|";
				}
			}
		}
            }
    } else {
            echo "Error ".$error." en expresión lógica|";
    }
}



function segundaVuelta(){

    global $raicesMatched;
    global $match,$error;
    global $WS;
    
    $match = FALSE;
    
    getLemas2();
    
    $raicesMatched = array();
    
    if($error==0){
	$WS[0]->resetAll();
	$match = $WS[0]->analizar(1);
    }
    
    printOutput();
}


function getLemas2(){

	global $pals,$raices;
	
	for($f=0;$f<count($raices);$f++){
		for($p=0;$p<count($raices[$f]);$p++){
			
			if(noMatch($f,$p)){
			
				$arrLemas = $raices[$f][$p];
				
				$buscarCorrs = TRUE;
				foreach($arrLemas as $lema => $arrPals){
					if(mb_ereg_match('[\d]',$lema) || $arrPals[0]==""){//Si la palabra contiene dígitos o es palabra no existente
						$buscarCorrs = FALSE;
						break;
					}
				}
				if($buscarCorrs){
					$arrLemas = addCorrs($arrLemas,$pals[$f][$p]);
				}
				
				$raices[$f][$p] = $arrLemas;
			}
		}
	}

}

function addCorrs($arrLemas,$pal){
	
	global $sug1,$sug2;
	
	$corrs = getCorreccionesErrorFrecuente_conSeed($pal);
	if(mb_strlen($pal)>3){
		getCorreccionLevenshtein_dst($pal,1,TRUE);
		$corrs = array_merge((array)$corrs,(array)$sug1);
		if(count($corrs)==0 && mb_strlen($pal)>5){
			$corrs = getConjCorrCombinaciones();
			getCorreccionLevenshtein_dst($pal,2,TRUE);
			$corrs = array_merge((array)$corrs,(array)$sug2);
		}
	}
	sort($corrs);
	$corrs = quitarDupl($corrs);
	
	foreach($corrs as $sugCorr){
		$raices = getRaices($sugCorr);
		foreach($raices as $raiz){
			if($arrLemas[$raiz]==null){
				$arrLemas[$raiz] = array($sugCorr);
			} else {
				array_push($arrLemas[$raiz],$sugCorr);
			}
		}
	}

	return $arrLemas;
}


function getRaices($sugCorr){
	
	$raices = consultDB($sugCorr,"morf_utf8","raiz");
	if(count($raices)==0){
		$raices = dbSecundarias($sugCorr,"raiz");
	}
	return $raices;
}


function noMatch($f,$p){
	
	global $raicesMatched;
	
	$noMatch = TRUE;

	foreach($raicesMatched as $datos){
		list($nFrase,$nPos,$lemaMatched) = $datos;
		if($nFrase==$f && $nPos==$p){
			$noMatch = FALSE;
			break;
		}
	}
	
	return $noMatch;
}


function getCorreccionSugerida(){
	
	global $pals,$frases;
	global $or;
	global $raices,$raicesMatched;
	
	$pals1D = array();
	
	for($f=0;$f<count($raices);$f++){
		for($p=0;$p<count($raices[$f]);$p++){
			$arrLemas = $raices[$f][$p];
			$hayCorr=FALSE;
			foreach($arrLemas as $lema=>$arrPals){
				foreach($arrPals as $pal){
					if($pal!=$pals[$f][$p] && $pal!=""){
						$hayCorr = TRUE;
						break;
					}
				}
			}
			if($hayCorr==FALSE){
				array_push($pals1D,$pals[$f][$p]);
			} else {
				//Si hubo match con algún lema --> sugerir las palabras correspondientes, exista o no la palabra original (escrita)
				$hayMatch = FALSE;
				foreach($raicesMatched as $datos){
					list($nFrase,$nPos,$lemaMatched) = $datos;
					if($nFrase==$f && $nPos==$p){
						foreach($arrLemas as $lema=>$arrPals){
							if($lemaMatched==$lema){
								$hayMatch = TRUE;
								array_push($pals1D,implode("/",$arrPals));
								break;
							}
						}
					}
					if($hayMatch){
						break;
					}
				}
				if($hayMatch==FALSE){
					$palInexist = FALSE;
					foreach($arrLemas as $lema=>$arrPals){
						if($arrPals[0]==""){
							$palInexist = TRUE;
							break;
						}
					}
					if($palInexist==FALSE){ //Si la palabra existe y no hubo match --> NO sugerir ningún cambio
						array_push($pals1D,$pals[$f][$p]);
					} else {
						$strCorrs = "";
						foreach($arrLemas as $lema=>$arrPals){
							if($lema != $pals[$f][$p]){
								if($strCorrs!=""){
									$strCorrs.="/";
								}
								$strCorrs.=implode("/",$arrPals);
							}
						}
						array_push($pals1D,$strCorrs);
					}
				}
			}
		}
	}
	
	
	$palsYSignos = separarPalsYSignos();
	
	
	$str = "";
	$rePal = '[\w\dáéíóúüñÁÉÍÓÚÜÑ-]+';
			
	for($i=0;$i<count($palsYSignos);$i++){
		$ente = $palsYSignos[$i];
		if(mb_ereg_match($rePal,$ente)){
			$pal = array_shift($pals1D);
			if($i<2 || mb_ereg_match('[\.\?\!¿¡]',$palsYSignos[$i-1])){
				$pal = ucfirst($pal);
			}
			$str.=$pal;
		} else {
			$str.=$ente;
		}
	}
	
	return $str;
}


function separarPalsYSignos(){
	
	global $or;
	$palsYSignos = array();

	$re = '/(([\s\.,;:¿\?¡\!]){1,2}|([\w\dáéíóúüñÁÉÍÓÚÜÑ]+))/i';
	preg_match_all($re,$or,$matches,PREG_OFFSET_CAPTURE);
	$matchesAll = $matches[1];
	for($i=0;$i<count($matchesAll);$i++){
		$ente = $matchesAll[$i][0];
		array_push($palsYSignos,$ente);
	}
	
	return $palsYSignos;
}



?>