<?php

/*
Vuelta 1: Sólo ofrecer corrección de palabras no existentes. Si erroresFrecuentes no arroja opciones válidas (pals existentes), entonces recurrir a levenstein 1 (incluyendo inversiones de letras), luego levenstein 2 en combinación con acentos, y, en última instancia, a similar_text
Vuelta 2: Para palabras no existentes, incluir todas las opciones de corrección. Para las existentes, sólo errores frecuentes o hasta donde se tenga que llegar para tener nuevas pals.
Vuelta 3: Para palabras existentes, también incluir todas las correcciones posibles

Hay entonces 4 niveles de corr (4 funciones):
1. Errores frecuentes (HAY QUE AGREGAR DEDAZOS POR POSICIÓN EN TECLADO!!!)
2. Levenstein 1, incluyendo inversión de 2 letras y adición de acentos (función addAcentos())
3. Levenstein 1 e inversión con adición de acentos, y levenstein 2 (para palabras de min. extensión), con adición de acentos (porque levenstein de php no considera caracteres "raros")
4. similar_text > 80-85

Habrá que hacer un array para cada palabra con nivel de corr ya realizado y pals correspondientes
*/

header('Content-Type: text/html; charset=utf-8');
mb_internal_encoding("UTF-8");

include 'erroresFrecuentes.php';
include 'levenshtein.php';
include 'similarTxt.php';


function getCorr($pal,$corrs,$vuelta){

	global $sug1,$sug2;
	
	if($vuelta==1){

		$corrs[0] = getCorreccionesErrorFrecuente_conSeed($pal);
		
		if(count($corrs[0])==0 || (count($corrs[0])==1 && $corrs[0][0]==$pal)){
			
			getCorreccionLevenshtein_dst($pal,1,TRUE);
			$corrs[1] = $sug1;
			
			if(count($corrs[1])==0 || (count($corrs[1])==1 && $corrs[1][0]==$pal)){
				
				$corrs[2] = getConjCorrCombinaciones();
				getCorreccionLevenshtein_dst($pal,2,TRUE);
				$corrs[2] = array_merge((array)$corrs[2],(array)$sug2);
				
				
				//$corrs[2] = array_merge((array)$corrs[2],errsFrecsConLevenstein1()); ---> DEMASIADO TARDADO
				
				/*if(mb_strlen($pal,'UTF-8')>5){
					$corrs[2] = getCorreccionLevenshtein_dst($pal,2,TRUE);
				} else {
					$corrs[2] = getPalsSimilares($pal,80); //con esto no se logra más de lo que ya se hizo en levenstein1 con addAcentos
				}*/
				
			}
		}

	} elseif($vuelta==2){
		
		if(count($corrs)==1){
			
			getCorreccionLevenshtein_dst($pal,1,TRUE);
			$corrs[1] = $sug1;
			
			if(count($corrs[1])==0 || (count($corrs[1])==1 && $corrs[1][0]==$pal)){
				
				$corrs[2] = getConjCorrCombinaciones();
				getCorreccionLevenshtein_dst($pal,2,TRUE);
				$corrs[2] = array_merge((array)$corrs[2],(array)$sug2);
			}
			
		} elseif(count($corrs)==2){
			
			$corrs[2] = getConjCorrCombinaciones();
			getCorreccionLevenshtein_dst($pal,2,TRUE);
			$corrs[2] = array_merge((array)$corrs[2],(array)$sug2);
		}
	}
	
	return $corrs;
}


?>