<?php

header('Content-Type: text/html; charset=utf-8');

mb_internal_encoding("UTF-8");
mb_regex_encoding("UTF-8");

$seed = "";
$combinaciones = array();

$totCol = 0;
$keys;

//echo "Correcciones:".join(", ",getCorreccionesErrorFrecuente_conSeed("satisfacido"));

function getCorreccionesErrorFrecuente_conSeed($s){
	
	global $seed;
	$seed = $s;
	if(!mb_check_encoding($seed, 'UTF-8')) $seed = utf8_encode($seed);
	$correcciones = getCorreccionesError();
	return $correcciones;
}

function getCorreccionesError(){
	
	global $seed;
	
	///PASO 1: Encontrar todas las letras conflictivas con su offset.
	$matrix = encontrarLetras();
	
	///PASO 2: Obtener todas las permutaciones posibles.
	permutar($matrix);
	
	///PASO 3: Comparar las combinaciones obtenidas con las palabras en AGME (diccionario morfológico)
	$sugerencias = getSugerenciasErrFrec();
	
	///PASO 4: Verbos irregulares
	$sugerencias = array_merge($sugerencias,verbosIrregulares($seed));
	
	///PASO 5: Superlativos
	$sugerencias = array_merge($sugerencias,superlativos($seed));
	
	/// PASO 6: Incluir errores de dedo teclado --> Esto no funciona demasiado bien, porque por ej. 'son' se vuelve 'sin' -> negación
	//$sugerencias = array_merge($sugerencias,getQwerty());
	
	sort($sugerencias);
	$sugerencias = quitarDupl($sugerencias);
	
	return $sugerencias;
}

function getCorreccionesErrorFrecuente_conSeed_sinSug($s){
	
	global $seed;
	
	//Sólo errores de grafías
	$seed = $s;
	$matrix = encontrarLetras();
	permutar($matrix);
	
}


////FUNCIONES PASO 1

function encontrarLetras(){
	
	$matriz = array();
	$matriz = vocal($matriz);
	$matriz = csz($matriz);
	$matriz = szFinal($matriz);
	$matriz = szCons($matriz);
	$matriz = ck($matriz);
	$matriz = qu($matriz);
	$matriz = vb($matriz);
	$matriz = gj($matriz);
	$matriz = ue($matriz);
	$matriz = yLl($matriz);
	$matriz = rr($matriz);
	$matriz = hMuda($matriz);
	$matriz = hMuda2($matriz);
		
	return $matriz;
}



function vocal($matriz){
	
	//When using accented characters and "ñ" (áéíóúñ), preg_match does not work. NO PUDE SOLUCIONARLO CON DECODE/ENCODE
	
	global $seed;
			
	for($i=0;$i<mb_strlen($seed,'UTF-8');$i++){
				
		if(mb_substr($seed,$i,1,'UTF-8')=="á" || mb_substr($seed,$i,1,'UTF-8')=="a"){
			$matriz[$i] = crearArrayLetras(array("a","á"),$matriz[$i]);
		} else if(mb_substr($seed,$i,1,'UTF-8')=="é" || mb_substr($seed,$i,1,'UTF-8')=="e"){
			$matriz[$i] = crearArrayLetras(array("e","é"),$matriz[$i]);
		} else if(mb_substr($seed,$i,1,'UTF-8')=="í" || mb_substr($seed,$i,1,'UTF-8')=="i"){
			$matriz[$i] = crearArrayLetras(array("i","í"),$matriz[$i]);
		} else if(mb_substr($seed,$i,1,'UTF-8')=="ó" || mb_substr($seed,$i,1,'UTF-8')=="o"){
			$matriz[$i] = crearArrayLetras(array("o","ó"),$matriz[$i]);
		} else if(mb_substr($seed,$i,1,'UTF-8')=="ú" || mb_substr($seed,$i,1,'UTF-8')=="u"){
			$matriz[$i] = crearArrayLetras(array("u","ú"),$matriz[$i]);
		}
	}
	
	return $matriz;
}


function csz($matriz){
	
	global $seed;
	
	$re1 = '^([csz])([eéií])';
	$re2 = '^([sz])([aáoóuú])';
	
	for($i=0;$i<mb_strlen($seed,'UTF-8')-1;$i++){
		$str = mb_substr($seed,$i);
		if(mb_ereg_match($re1,$str)){
			$matriz[$i] = crearArrayLetras(array("c","s","z"),$matriz[$i]);
		} else if(mb_ereg_match($re2,$str)){
			$matriz[$i] = crearArrayLetras(array("s","z"),$matriz[$i]);
		}
	}
	
	return $matriz;
}



function szFinal($matriz){
	
	global $seed;
	
	$offset = mb_strlen($seed,'UTF-8')-1;
	if(mb_substr($seed,$offset,1) == "s" || mb_substr($seed,$offset,1) == "z"){
		$matriz[$offset] = crearArrayLetras(array("s","z"),$matriz[$i]);
	}
	
	return $matriz;
}


function szCons($matriz){
	
	global $seed;
	$re = '^([sz])([bcdlmnprt])';  //aborrezco, hazlo, hazme
	for($i=0;$i<mb_strlen($seed,'UTF-8')-1;$i++){
		$str = mb_substr($seed,$i);
		if(mb_ereg_match($re,$str)){
			$matriz[$i] = crearArrayLetras(array("s","z"),$matriz[$i]);
		}
	}
	return $matriz;
}


function ck($matriz){
	
	global $seed;
	$re = '^([ck])[aáoóuúübclmnrst]';
	for($i=0;$i<mb_strlen($seed,'UTF-8')-1;$i++){
		$str = mb_substr($seed,$i);
		if(mb_ereg_match($re,$str)){
			$matriz[$i] = crearArrayLetras(array("c","k"),$matriz[$i]);
		}
	}
	return $matriz;
}


function qu($matriz){
	
	global $seed;
	$re = '^(k)[eéií]';
	for($i=0;$i<mb_strlen($seed,'UTF-8')-1;$i++){
		$str = mb_substr($seed,$i);
		if(mb_ereg_match($re,$str)){
			$matriz[$i] = crearArrayLetras(array("k","qu"),$matriz[$i]);
		}
	}
	return $matriz;
}


function vb($matriz){
	
	global $seed;
	$re = '^[vb]';
	for($i=0;$i<mb_strlen($seed,'UTF-8');$i++){
		$str = mb_substr($seed,$i);
		if(mb_ereg_match($re,$str)){
			$matriz[$i] = crearArrayLetras(array("v","b"),$matriz[$i]);
		}
	}
	return $matriz;
}


function gj($matriz){
	
	global $seed;
	$re = '^([gj])[eéií]';
	for($i=0;$i<mb_strlen($seed,'UTF-8')-1;$i++){
		$str = mb_substr($seed,$i);
		if(mb_ereg_match($re,$str)){
			if(mb_substr($str,0,1)=="g"){
				$letras = crearArrayLetras(array("g","j","gu"),$matriz[$i]);
			} else {
				$letras = crearArrayLetras(array("g","j"),$matriz[$i]);
			}
			$matriz[$i] = $letras;
		}
	}
	return $matriz;
}


function ue($matriz){
	global $seed;
	$re = '^(gu)[eéií]';
	for($i=0;$i<mb_strlen($seed,'UTF-8')-2;$i++){
		$str = mb_substr($seed,$i);
		if(mb_ereg_match($re,$str)){
			$matriz[$i+1] = crearArrayLetras(array("ü"),$matriz[$i+1]);
		}
	}
	return $matriz;
}


function yLl($matriz){
	global $seed;
	$re = '^(y|ll)[aeiouáéíóúü]';
	for($i=0;$i<mb_strlen($seed,'UTF-8')-1;$i++){
		$str = mb_substr($seed,$i);
		if(mb_ereg_match($re,$str)){
			$matriz[$i] = crearArrayLetras(array("y","ll"),$matriz[$i]);
		}
	}
	return $matriz;
}


function rr($matriz){
	global $seed;
	$re = '^[aeiouáéíóúü](r)[aeiouáéíóúü]';
	for($i=0;$i<mb_strlen($seed,'UTF-8')-2;$i++){
		$str = mb_substr($seed,$i);
		if(mb_ereg_match($re,$str)){
			$matriz[$i+1] = crearArrayLetras(array("rr"),$matriz[$i+1]);
		}
	}
	return $matriz;
}



///Si la palabra inicia con vocal, la sustitución de esta vocal por su versión con o son acento estaría en posición 0
function hMuda($matriz){
	global $seed;
	$re = '^[aeiouáéíóúü]';
	if(mb_ereg_match($re,$seed)){
		$matriz[-1] = crearArrayLetras(array("h"),$matriz[-1]);
	}
	return $matriz;
}

function hMuda2($matriz){
	global $seed;
	$re = '^h([aeiouáéíóúü])';
	if(mb_ereg_match($re,$seed)){
		$matriz[0] = crearArrayLetras(array(" "),$matriz[0]);
	}
	return $matriz;
}



function crearArrayLetras($letras,$arr){

	global $totCol;
	$totCol = 26;

	if(!is_array($arr)){
		$arr = array(
			'a'=>FALSE,'e'=>FALSE,'i'=>FALSE,'o'=>FALSE,'u'=>FALSE,
			'á'=>FALSE,'é'=>FALSE,'í'=>FALSE,'ó'=>FALSE,'ú'=>FALSE,
			'c'=>FALSE,'s'=>FALSE,'z'=>FALSE,'k'=>FALSE,'qu'=>FALSE,
			'v'=>FALSE,'b'=>FALSE,
			'g'=>FALSE,'j'=>FALSE,'gu'=>FALSE,
			'ü'=>FALSE,
			'y'=>FALSE,'ll'=>FALSE,
			'rr'=>FALSE,
			'h'=>FALSE,
			' '=>FALSE
			//'d'=>FALSE,'f'=>FALSE,'l'=>FALSE,'m'=>FALSE,'n'=>FALSE,'p'=>FALSE,'q'=>FALSE,'r'=>FALSE,'t'=>FALSE,'w'=>FALSE,'x'=>FALSE
		);
	}
			
	for($i=0;$i<count($letras);$i++){
		$l = $letras[$i];
		$arr[$l]=TRUE;
	}
	
	return $arr;
}


////FUNCIONES PASO 2 (ALGORITMO DE PERMUTACIÓN)

/*
Los offsets están en los rows y las letras en las columnas. En mayúsculas se indica donde inicia el algoritmo
Ejemplo: suceso
		c		s		z
0		false	true	true	
2		true	true	false
4		FALSE	true	true
*/


function permutar($matriz){

	global $seed;
	global $combinaciones;
	
	$combinaciones = array($seed=>array());
	
	$arr = array();
	getNext(count($matriz),1,$matriz,$arr);
	
}

// Se obtienen todas las nuevas combinaciones por row, es decir, por offset.

function getNext($targetRow,$targetCol,$matriz,$nuevasComb){

	global $combinaciones;
	global $totCol;

	$continuar=TRUE;
	
	$numRow = 0;
	foreach($matriz as $offset => $letras){
		if($continuar){
			$numRow++;
			if($numRow==$targetRow){
				//recuperar letra en posición targetCol
				$numCol = 0;
				foreach($letras as $letra => $bool){
					$numCol++;
					if($numCol==$targetCol){			
						if($bool==TRUE){
							$nuevasComb = array_merge((array)$nuevasComb,(array)sustituirLetra($offset,$letra));
						}
						if($targetCol<$totCol){
							getNext($targetRow,$targetCol+1,$matriz,$nuevasComb);
						} else {
							cambiarRow($targetRow,$matriz,$nuevasComb);
						}
						$continuar=FALSE;
						break;
					} 
				}
			}
		} else {
			break;
		}
	}
}

///El array 'cambios' se guarda para tomar en cuenta cambios en largo de la palabra. Ver combinaciones para 'alusinar' (cambio de número de caracteres y, por lo mismo, debe ajustarse el offset).

function sustituirLetra($offset,$letra){
	
	global $combinaciones;
	$nuevasComb = array();
	
	foreach($combinaciones as $pal=>$cambios){
				
		$comb;
		$cambio = array();
		$newOffset = getNewOffset($offset,$cambios);

		//substr_replace cuenta los caracteres acentuados como 2, por lo que no hacía la sustitución en el lugar adecuado.

		if($letra=="h"){
			//$comb = substr_replace($pal,$letra,0,0);
			$comb = "h".$pal;
			$cambio[-1] = 1;
		} else if($letra=="y" && substr($pal,$newOffset,1)=="l"){
			//$comb = substr_replace($pal,$letra,$newOffset,2);
			$comb = mb_substr($pal,0,$newOffset,'UTF-8')."y".mb_substr($pal,$newOffset+2,mb_strlen($pal,'UTF-8')-($newOffset+2),'UTF-8');
			$cambio[$offset] = -1;
		} else if($letra==" "){
			//quitar la h muda inicial
			//$comb = substr_replace($pal,"",0,1);
			//$comb = mb_substr($pal,1,-1,'UTF-8');
			$comb = mb_substr($pal,1,mb_strlen($pal,'UTF-8')-1,'UTF-8');
			$cambio[0] = -1;
		} else {
			//$comb = substr_replace($pal,$letra,$newOffset,1);
			$comb = mb_substr($pal,0,$newOffset,'UTF-8').$letra.mb_substr($pal,$newOffset+1,mb_strlen($pal,'UTF-8')-($newOffset+1),'UTF-8');
			if($letra=="ll" || $letra=="rr" || $letra=="gu" || $letra=="qu"){
				$cambio[$offset] = 1;
			}
		}
		
		if(enMap($comb,$combinaciones)==FALSE){
			//si se usa el array_merge, los keys se convierten en 0,1,...
			$cambios2 = mergeMaps($cambios,$cambio); //array_merge((array)$cambios,(array)$cambio); 
			$nuevasComb[$comb] = $cambios2;
		}
	}
	return $nuevasComb;
}

function getNewOffset($offset,$cambios){
		
	if(count($cambios)>0){
		$dif = 0;
		foreach($cambios as $charCambio => $cambioLength){
			if( (int)$charCambio < $offset ){
				$dif+=$cambioLength;
			}
		}
		$offset+=$dif;
	}
	
	return $offset;
}

function cambiarRow($targetRow,$matriz,$nuevasComb){
	
	global $combinaciones;
	$combinaciones = array_merge((array)$combinaciones,(array)$nuevasComb);
	if($targetRow>1){
		$arr = array();
		getNext($targetRow-1,1,$matriz,$arr);
	}
}

function mergeMaps($arr1,$arr2){
	foreach($arr1 as $key=>$value){
		if($arr2[$key]==null){
			$arr2[$key]=$value;	
		}	
	}
	return $arr2;
}


///FUNCION PASO 3

function getSugerenciasErrFrec(){
	
	global $combinaciones;
	$sugs = array();

	foreach($combinaciones as $combinacion => $array){
		
		$sugLoc = consultDB($combinacion,"morf_utf8","palabra");
		
		if(count($sugLoc)==0){
			$sugLoc = dbSecundarias($combinacion,"palabra");
		}
		
		$sugs = array_merge((array)$sugs,(array)$sugLoc);
	}
		
	return $sugs;
}



//// PASO 4: agregar conjugaciones erróneas de verbos irregulares

function verbosIrregulares($seed){
	
	$arr = array();
	
	$seeds = addAcentos($seed);
	array_push($seeds,$seed);

	$dbh = connectToDB();
	mysql_select_db("morfo", $dbh);
	
	foreach($seeds as $s){
		
		$query  = "SELECT * FROM conjErr WHERE incorr='$s'";
		$res = mysql_query($query,$dbh);
		while($row = mysql_fetch_array($res)){
			array_push($arr,$row['corr']);
		}
	}
	
	mysql_close($dbh);
	
	return $arr;
}

function getConjCorrCombinaciones(){
	
	//checar si las combinaciones de errores frecuentes corresponden a una conjugación incorrecta
	
	global $combinaciones;
	$sugs = array();
	
	$dbh = connectToDB();
	mysql_select_db("morfo", $dbh);
	
	$queryStr = "(";
	foreach($combinaciones as $combinacion => $array){
		$queryStr .= "incorr='$combinacion' OR ";
	}
	$queryStr = substr_replace($queryStr,"",strlen($queryStr)-4,4);
	$queryStr .= ")";
	
	$query  = "SELECT * FROM conjErr WHERE ".$queryStr;
	$result = mysql_query($query,$dbh);
	while($row = mysql_fetch_array($result)){
		if(in_array($row['corr'],$sugs)==FALSE){
			array_push($sugs,$row['corr']);
		}
	}
	mysql_close($dbh);
	
	return $sugs;
}



/// PASO 5: corrección de superlativos irregulares

function superlativos($seed){
	
	$arr = array();
	
	$superl = array(
			"acrísim" => "acérrim",
			"agrísim" => "acérrim",
			"antigüísim" => "antiquísim",
			"antiguísim" => "antiquísim",
			"ardientísim" => "ardentísim",
			"celebresísim" => "celebérrim",
			"celebrísim" => "celebérrim",
			"epiquísim" => "epiquérrim",
			"fielísim" => "fidelísim",
			"integrísim" => "integérrim",
			"librísim" => "libérrim",
			"miserísim" => "misérrim",	
			"nuestrísim" => "nostrísim",
			"nuevísim" => "novísim",
			"pulcrísim" => "pulquérrim",
			"salubrísim" => "salubérrim",
			"seriísim" => "seriecísim",
			"serísim" => "seriecísim"
			);
	
	if(mb_ereg('[íi]sim[oa]s?$',$seed)){
		
		if(mb_ereg('isim[oa]s?$',$seed)){
			$seed = mb_ereg_replace('isim','ísim',$seed);
		}
		mb_ereg('(.+)(o|a|os|as)$',$seed,$matches);
		$base = $matches[1];
		$term = $matches[2];
		
		foreach($superl as $err => $corr){
			if($base == $err){
				array_push($arr,$corr.$term);
				break;
			}
		}
	}
	
	return $arr;
}



//// PASO 6: agregar errores tipográficos por cercanía en teclado

/*
function getQwerty(){
	
	global $seed;
	
	$qwerty_sust = array("a"=>array('q','w','s','z'),"b"=>array('v','g','h','n'),"c"=>array('x','d','f','v'),"d"=>array('s','e','r','f','x','c'),"e"=>array('w','r','s','d'),"f"=>array('d','g','r','t','c','v'),"g"=>array('f','h','t','y','v','b'),"h"=>array('g','j','y','u','b','n'),"i"=>array('u','o','j','k'),"j"=>array('h','k','u','i','n','m'),
		"k"=>array('j','l','i','o','m'),"l"=>array('k','ñ','o','p'),"m"=>array('n','j','k'),"n"=>array('b','m','h','j'),"o"=>array('i','p','k','l'),"p"=>array('o','l','ñ'),"q"=>array('w','a'),"r"=>array('e','t','d','f'),"s"=>array('a','d','w','e','z','x'),"t"=>array('r','y','f','g'),"u"=>array('y','i','h','j'),
		"v"=>array('c','b','f','g'),"w"=>array('q','e','a','s'),"x"=>array('z','c','s','d'),"y"=>array('t','u','g','h'),"z"=>array('x','a','s'),"á"=>array('s','q','w','z'),"é"=>array('w','r','s','d'),"í"=>array('u','o','j','k'),"ó"=>array('i','p','k','l'),"ú"=>array('y','i','h','j'),"ü"=>array('y','i','h','j'),"ñ"=>array('l','p'));

	$arr = array();
	for($i=0;$i<mb_strlen($seed,'UTF-8');$i++){
		$letra = mb_substr($seed,$i,1);
		$letras = $qwerty_sust[$letra];
		for($j=0;$j<count($letras);$j++){
			//$pal2 = substr_replace($seed,$letras[$j],$i,1);
			$pal = mb_substr($seed,0,$i,'UTF-8').$letras[$j].mb_substr($seed,$i+1,mb_strlen($seed,'UTF-8')-($i+1),'UTF-8');
			array_push($arr,$pal);
		}
	}
	
	$arr = getSugerenciasQwerty($arr);
	
	return $arr;

}


function getSugerenciasQwerty($pals){
	
	$sugs = array();
	
	$dbh = connectToDB();
	mysql_select_db("morfo", $dbh);
	
	$queryStr = "(";
	foreach($pals as $key => $value){
		$queryStr .= "palabra='$value' OR ";
	}
	$queryStr = substr_replace($queryStr,"",strlen($queryStr)-4,4);
	$queryStr .= ")";
	$query  = "SELECT * FROM morf_utf8 WHERE ".$queryStr;
	$result = mysql_query($query,$dbh);
	while($row = mysql_fetch_array($result)){
		if(in_array($row['palabra'],$sugs)==FALSE){
			array_push($sugs,$row['palabra']);
		}
	}
	mysql_close($dbh);
	
	return $sugs;
}
 */



///// COMBINACIÓN ERRORES FRECUENTES + LEVENSTEIN 1

function errsFrecsConLevenstein1(){

	global $combinaciones;
	
	$arrTot = array();

	foreach($combinaciones as $key=>$value){
		$arrTot = array_merge((array)$arrTot,getPalabrasLevenshteinPHP($key,1));
	}
	
	sort($arrTot);
	$arrTot = quitarDupl($arrTot);
	
	return $arrTot;
}



///OTRAS FUNCIONES

function enMap($w,$arr){
	$b = FALSE;
	foreach($arr as $key => $value){
		if($key==$w){
			$b = TRUE;	
			break;
		}
	}
	return $b;	
}


?>