<?php

header('Content-Type: text/html; charset=utf-8');

mb_internal_encoding("UTF-8");

include 'erroresFrecuentes.php';
include 'levenshtein.php';
include 'similarTxt.php';
include 'funcionesCompartidas.php';

error_reporting(E_ERROR | E_PARSE); //NO incluyo E_WARNING PORQUE PUEDE ALTERAR LOS STRINGS DE ECHO Y, POR ENDE, EL RESULTADO

$corr = $_POST["c"];
$or = urldecode($_POST["o"]);

/*
$corr = $_GET["c"];
$or = urldecode($_GET["o"]);
*/

$frases = mb_split('[.,;:¿?!¡]+',$or);
$pals = separarPalsFrase($frases);

$arrFrases = getLemas1($pals,$corr);
$strFrase = makeString($arrFrases);
echo $strFrase;

function separarPalsFrase($frases){
	
	$arr2D = array();
	$re1 = '/([\w\dáéíóúüñÁÉÍÓÚÜÑ]+)/i';
	
	for($f=0;$f<count($frases);$f++){
		$arr = array();
		preg_match_all($re1,$frases[$f],$matches,PREG_OFFSET_CAPTURE);
		$matchesPals = $matches[1];
		for($i=0;$i<count($matchesPals);$i++){
			$palabra = $matchesPals[$i][0];
			array_push($arr,$palabra);
		}
		array_push($arr2D,$arr);
	}	
	return $arr2D;
}


function getLemas1($pals,$corr){
	
	global $sug1,$sug2;
	
	$raices = array();
	
	for($f=0;$f<count($pals);$f++){
		
		$raicesFrase = array();
		
		for($i=0;$i<count($pals[$f]);$i++){
			
			$lemas = array();
			$pal = strToLc($pals[$f][$i]);
			
			$matches1 = consultDB($pal,"morf_utf8","raiz");
			$matches2 = dbSecundarias($pal,"raiz");
			$matches = array_merge((array)$matches1,(array)$matches2);
			sort($matches);
			$matches = quitarDupl($matches);

			if(count($matches)==0){
				
				if(mb_ereg_match('[\d]',$pal)){
					//Si la palabra es o contiene un número, no se considera una palabra mal escrita o no existente
					$lemas[$pal] = array($pal);
					
				} else {
					//Si el valor del primer key (lema) en $raices es un array con cadena vacía, entonces la palabra no existe
					$lemas[$pal] = array("");
					
					if($corr!="off" && mb_strlen($pal)>1){
						$corrs = getCorreccionesErrorFrecuente_conSeed($pal);
						if(mb_strlen($pal)>3){
							getCorreccionLevenshtein_dst($pal,1,TRUE);
							$corrs = array_merge((array)$corrs,(array)$sug1);
							if(count($corrs)==0 && mb_strlen($pal)>5){
								$corrs = getConjCorrCombinaciones();
								getCorreccionLevenshtein_dst($pal,2,TRUE);
								$corrs = array_merge((array)$corrs,(array)$sug2);
							}
						}
						sort($corrs);
						$corrs = quitarDupl($corrs);
						
						foreach($corrs as $sugCorr){
							$raices = consultDB($sugCorr,"morf_utf8","raiz");
							if(count($raices)==0){
								$raices = dbSecundarias($sugCorr,"raiz");
							}
							foreach($raices as $raiz){
								if($lemas[$raiz]==null){
									$lemas[$raiz] = array($sugCorr);
								} else {
									array_push($lemas[$raiz],$sugCorr);
								}
							}
						}
					}
				}
				
			} else {				
				foreach($matches as $lema){
					$lemas[$lema] = array($pal);
				}
				//Recuerda caso "ley de Charles" ---> Hay que agregar también la palabra original como lema por si acaso se trata de un nombre u otra expresión que también existe como palabra
				if($lemas[$pal]==null){
					$lemas[$pal] = array($pal);
				}
			}	
			
			$raicesFrase[$i] = $lemas;
			
		}
				
		array_push($raices,$raicesFrase);
	}
	
	return $raices;
}


function makeString($arrFrases){
	
	$strFrases = "";
	
	foreach($arrFrases as $arrPos){
		$strPos = "";
		foreach($arrPos as $arrLemas){
			$strLema = "";
			foreach($arrLemas as $lema=>$arrPals){
				$str = $lema."->".implode(",",$arrPals);
				if($strLema!=""){
					$strLema.="/";
				}
				$strLema.=$str;
			}
			if($strPos!=""){
				$strPos.="//";
			}
			$strPos.=$strLema;
		}
		if($strFrases!=""){
			$strFrases.="///";
		}
		$strFrases.=$strPos;
	}
	
	return $strFrases;
}


?>